/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Entities;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

/**
 *
 * @author puzsaai
 */
@Entity(name = "Alap")//adatbázis beli neve a táblának
public class Alap implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    //Pizza tulajdonságai
    @Column(length = 30)
    private String name;
    private int ar;
    private int atmero;
    private boolean hajtott;

    //Egy pizzához több feltét is tartozhat
    @OneToMany
    private Set<Feltet> feltetek = new HashSet<>();
    
    //Visszadjuk a pizza árát (alap+feltétek)
    public int getPriceWithFeltets(){
        int sum = ar;
        
        for(Feltet f : feltetek){
            sum += f.getAr();
        }
        
        return sum;
    }
    
    public int getAtmero() {
        return atmero;
    }

    public void setAtmero(int atmero) {
        this.atmero = atmero;
    }
    
    public Set<Feltet> getFeltetek() {
        return feltetek;
    }

    public void setFeltetek(Set<Feltet> feltetek) {
        this.feltetek = feltetek;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getAr() {
        return ar;
    }

    public void setAr(int ar) {
        this.ar = ar;
    }

    public boolean isHajtott() {
        return hajtott;
    }

    public void setHajtott(boolean hajtott) {
        this.hajtott = hajtott;
    }
    
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Alap)) {
            return false;
        }
        Alap other = (Alap) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "Entities.Alap[ id=" + id + " ]";
    }
    
}
