/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GUI;

import Entities.Alap;
import Entities.Feltet;
import Logic.Logic;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author puzsaai
 */
public class FeltetTable {
    /*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
    private JTable table ;
    private myTableModel tableModel;
    
    public FeltetTable( Alap a){
        tableModel = new myTableModel();
        table = new JTable(tableModel);
        
        Logic logic = Logic.getInstance();
        if(a != null){//Ha van kijelölve egy pizza alap
            for(Feltet f : a.getFeltetek()){//Akkor a hozzá tartozó feltéteket jelenítjük meg
                tableModel.addFeltet(f);
            }
        } else {//egyébként minden feltétet megjelenítjük
            for(Feltet f : logic.getFeltets()){
                tableModel.addFeltet(f);
            }
        }
    }
    
    //Ha ki van jelölve egy sor, akkor az ahhoz tartozó pizza feltétet visszaadja,
    //különben null-t ad vissza.
    public Feltet getSelectedFeltet(){
        if(table.getSelectedRow() != -1){
            return tableModel.getSelectedFeltet(table.getSelectedRow());
        } else {
            return null;
        }
    }

    public JTable getTable() {
        return table;
    }
    
    
    private class myTableModel extends AbstractTableModel{
        private String[] columns = {"Név","ár"};
        private List<Feltet> data = new ArrayList<>();

        public void addFeltet(Feltet a){
            data.add(a);
            fireTableDataChanged();
        }
        
        public Feltet getSelectedFeltet(int row){
            return data.get(row);
        }
        
        @Override
        public int getRowCount() {
            return data.size();
        }

        @Override
        public int getColumnCount() {
            return columns.length;
        }

        @Override
        public Object getValueAt(int rowIndex, int columnIndex) {
            Feltet a = data.get(rowIndex);
            switch(columnIndex){
                case 0:
                    return a.getName();
                case 1:
                    return a.getAr();
                default:
                    return null;
            }
        }

        @Override
        public String getColumnName(int column) {
            return columns[column];
        }
        
        
        @Override
        public Class<?> getColumnClass(int columnIndex) {
            Object o = getValueAt(0, columnIndex);
            if(o != null){
                return o.getClass();
            } else {
                return null;
            }
        }
        
        //A feltéteket ne tudjuk módosítani
        @Override
        public boolean isCellEditable(int rowIndex, int columnIndex) {
                return false;
        }
    }
}
