/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GUI;

import Entities.Alap;
import Logic.Logic;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author puzsaai
 */
public class PizzaTable {
    private JTable table ;
    private myTableModel  tableModel ;
    
    public PizzaTable(final GUI gui){
        tableModel = new myTableModel();
        table = new JTable(tableModel);
        
        Logic logic = Logic.getInstance();//Logikai réteg elérése
        for(Alap a : logic.getAlaps()){//Minden alapot megjelenítünk
            tableModel.addAlap(a);
        }
        
        //Egér kattintás figyelése
        table.addMouseListener(new MouseAdapter() {

            @Override
            public void mouseClicked(MouseEvent e) {
                gui.refreshFeltetTable();//a GUI rétegnél frissítjük a pizza-alap táblát
            }
           });
    }
    
    //Ha ki van jelölve egy sor, akkor az ahhoz tartozó pizza alapot visszaadja,
    //különben null-t ad vissza.
    public Alap getSelectedAlap(){
        if(table.getSelectedRow() != -1){
            return tableModel.getSelectedAlap(table.getSelectedRow());
        } else {
            return null;
        }
    }

    //Getter
    public JTable getTable() {
        return table;
    }
    
    private class myTableModel extends AbstractTableModel{
        private String[] columns = {"Név","Átmérő","ár","Hajtott"};
        private List<Alap> data = new ArrayList<>();

        public void addAlap(Alap a){
            data.add(a);
            fireTableDataChanged();
        }
        
        public Alap getSelectedAlap(int row){
            return data.get(row);
        }
        
        @Override
        public int getRowCount() {
            return data.size();
        }

        @Override
        public int getColumnCount() {
            return columns.length;
        }

        @Override
        public Object getValueAt(int rowIndex, int columnIndex) {
            Alap a = data.get(rowIndex);
            switch(columnIndex){
                case 0:
                    return a.getName();
                case 1:
                    return a.getAtmero();
                case 2:
                    return a.getAr();
                case 3:
                    return a.isHajtott();
                default:
                    return null;
            }
        }
        
        @Override
        public String getColumnName(int column) {
            return columns[column];
        }

        @Override
        public Class<?> getColumnClass(int columnIndex) {
            Object o = getValueAt(0, columnIndex);
            if(o != null){
                return o.getClass();
            } else {
                return null;
            }
        }

        @Override
        public boolean isCellEditable(int rowIndex, int columnIndex) {
            return columnIndex < 3;
        }

        @Override
        public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
            Alap a = data.get(rowIndex);
            switch(columnIndex){
                case 0:
                    a.setName((String)aValue);
                    break;
                case 1:
                    a.setAtmero((Integer)aValue);
                    break;
                case 2:
                    a.setAr((Integer)aValue);
                    break;
                case 3:
                    a.setHajtott((Boolean)aValue);
                    break;
            }
            //Miután módosult a GUI, módosítjuk az adatbázist is!
            Logic l = Logic.getInstance();
            l.updateAlap(a);
        }
    }
}
