/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Logic;

import Entities.Alap;
import Entities.AlapJpaController;
import Entities.Feltet;
import Entities.FeltetJpaController;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 *
 * @author puzsaai
 */
public class Logic {
    //Kontroller osztályok
    private AlapJpaController alapJPAC ;
    private FeltetJpaController feltetJPAC;
    
    /**
     * Singleton Logic osztály(nem kötelező, de egyébként végig kell adni egy
     * példányt a GUI rétegeknek)
     * Kontroller osztályok létrehozása
     */
    private Logic(){
        EntityManagerFactory factory = Persistence.createEntityManagerFactory("PizzaPU");
        alapJPAC = new AlapJpaController(factory);
        feltetJPAC = new FeltetJpaController(factory);
    }
    
    public static Logic getInstance(){
        return InstanceHolder.instance;
    }
    
    private static class InstanceHolder{
        private static final Logic instance = new Logic();
    }
    
    //Összes pizza alap lekérése
    public List<Alap> getAlaps(){
        return alapJPAC.findAlapEntities();
    }
    
    //Összes feltét lekérése
    public List<Feltet> getFeltets(){
        return feltetJPAC.findFeltetEntities();
    }
    
    //Pizza-alap frissítése az adatbázisban
    public void updateAlap(Alap a){
        try {
            alapJPAC.edit(a);
        } catch (Exception ex) {
            Logger.getLogger(Logic.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    //Egy pizza alapról levesz egy feltétet
    public void deleteFeltetFromAlap(Alap alap, Feltet feltet){
        alap.getFeltetek().remove(feltet);//Levesszük a feltétek közül a paraméterben kapotatt
        try {
            alapJPAC.edit(alap);//Módosítjuk az alap-táblát az adatbázisban
        } catch (Exception ex) {
            Logger.getLogger(Logic.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    
    //Egy pizza-alaphoz ad egy másik feltétet
    public void addFeltetToAlap(Alap alap, String feltetString){
        Feltet feltet = null;
        for(Feltet f : getFeltets()){
            if(f.getName() == null ? feltetString == null : f.getName().equals(feltetString)){
                feltet = f;
                break;
            }
        }
        
        if(feltet != null){//Megtaláltuk a feltétet
            
            alap.getFeltetek().add(feltet);//hozzáadjuk a meglévőkhoz
            //Mivel ez egy halmaz, azért kétszer nem fog megjelenni egy feltét sem.
            //Ha mégis ezt akarjuk, akkor List<Feltet> feltetek =...; -ként hozzuk létre
            //az Alap.java Entity osztályban
            
            try {
                alapJPAC.edit(alap);//Módosítjuk az adatbázist
            } catch (Exception ex) {
                Logger.getLogger(Logic.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}
