package swingschooljpa.logic;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import swingschooljpa.logic.controllers.GroupAssignmentJpaController;
import swingschooljpa.logic.controllers.GrouppJpaController;
import swingschooljpa.logic.controllers.MarkJpaController;
import swingschooljpa.logic.controllers.StudentJpaController;
import swingschooljpa.logic.controllers.SubjectJpaController;
import swingschooljpa.logic.controllers.TeacherJpaController;

public class DataSource {
    
    private DataSource() {
        teacherJpaController = new TeacherJpaController(getEntityManagerFactory());
        studentJpaController = new StudentJpaController(getEntityManagerFactory());
        markJpaController = new MarkJpaController(getEntityManagerFactory());
        subjectJpaController = new SubjectJpaController(getEntityManagerFactory());
        groupAssignmentJpaController = new GroupAssignmentJpaController(getEntityManagerFactory());
        grouppJpaController = new GrouppJpaController(getEntityManagerFactory());
    }
    
    public static DataSource getInstance() {
        return DataSourceHolder.INSTANCE;
    }
    
    private static class DataSourceHolder {

        private static final DataSource INSTANCE = new DataSource();
    }
    
    public final EntityManagerFactory getEntityManagerFactory(){
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("SwingSchoolJpaPU");
        return emf;
    }
    
    private StudentJpaController studentJpaController;
    private MarkJpaController markJpaController;
    private SubjectJpaController subjectJpaController;
    private GrouppJpaController grouppJpaController;
    private GroupAssignmentJpaController groupAssignmentJpaController;
    private TeacherJpaController teacherJpaController;

    public StudentJpaController getStudentJpaController() {
        return studentJpaController;
    }

    public MarkJpaController getMarkJpaController() {
        return markJpaController;
    }

    public SubjectJpaController getSubjectJpaController() {
        return subjectJpaController;
    }

    public GrouppJpaController getGrouppJpaController() {
        return grouppJpaController;
    }

    public GroupAssignmentJpaController getGroupAssignmentJpaController() {
        return groupAssignmentJpaController;
    }

    public TeacherJpaController getTeacherJpaController() {
        return teacherJpaController;
    }
    
    
}
