/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package swingschooljpa.logic.controllers;

import java.io.Serializable;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Query;
import javax.persistence.EntityNotFoundException;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;
import swingschooljpa.logic.controllers.exceptions.NonexistentEntityException;
import swingschooljpa.logic.entities.GroupAssignment;

/**
 *
 * @author lengyel
 */
public class GroupAssignmentJpaController implements Serializable {

    public GroupAssignmentJpaController(EntityManagerFactory emf) {
        this.emf = emf;
    }
    private EntityManagerFactory emf = null;

    public EntityManager getEntityManager() {
        return emf.createEntityManager();
    }

    public void create(GroupAssignment groupAssignment) {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            em.persist(groupAssignment);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void edit(GroupAssignment groupAssignment) throws NonexistentEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            groupAssignment = em.merge(groupAssignment);
            em.getTransaction().commit();
        } catch (Exception ex) {
            String msg = ex.getLocalizedMessage();
            if (msg == null || msg.length() == 0) {
                Integer id = groupAssignment.getId();
                if (findGroupAssignment(id) == null) {
                    throw new NonexistentEntityException("The groupAssignment with id " + id + " no longer exists.");
                }
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void destroy(Integer id) throws NonexistentEntityException {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            GroupAssignment groupAssignment;
            try {
                groupAssignment = em.getReference(GroupAssignment.class, id);
                groupAssignment.getId();
            } catch (EntityNotFoundException enfe) {
                throw new NonexistentEntityException("The groupAssignment with id " + id + " no longer exists.", enfe);
            }
            em.remove(groupAssignment);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public List<GroupAssignment> findGroupAssignmentEntities() {
        return findGroupAssignmentEntities(true, -1, -1);
    }

    public List<GroupAssignment> findGroupAssignmentEntities(int maxResults, int firstResult) {
        return findGroupAssignmentEntities(false, maxResults, firstResult);
    }

    private List<GroupAssignment> findGroupAssignmentEntities(boolean all, int maxResults, int firstResult) {
        EntityManager em = getEntityManager();
        try {
            CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
            cq.select(cq.from(GroupAssignment.class));
            Query q = em.createQuery(cq);
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            return q.getResultList();
        } finally {
            em.close();
        }
    }

    public GroupAssignment findGroupAssignment(Integer id) {
        EntityManager em = getEntityManager();
        try {
            return em.find(GroupAssignment.class, id);
        } finally {
            em.close();
        }
    }

    public int getGroupAssignmentCount() {
        EntityManager em = getEntityManager();
        try {
            CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
            Root<GroupAssignment> rt = cq.from(GroupAssignment.class);
            cq.select(em.getCriteriaBuilder().count(rt));
            Query q = em.createQuery(cq);
            return ((Long) q.getSingleResult()).intValue();
        } finally {
            em.close();
        }
    }
    
}
